package cs108.e;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

public final class Dump {
    public static void main(String[] args) throws IOException {
        // Version 4, qui lit les octets par groupe de 16, les affiche
        // en hexadécimal (base 16) et affiche aussi les octets interprétés
        // comme caractères ASCII imprimables.
        try (InputStream s = new FileInputStream("allbytes.bin")) {
            int count, pos = 0;
            byte[] bs = new byte[16];
            while ((count = s.readNBytes(bs, 0, 16)) != 0) {
                System.out.printf("%05x:", pos);
                for (int b = 0; b < count; ++b)
                    System.out.printf(" %02x", bs[b]);

                System.out.print("  |");
                for (int b = 0; b < count; ++b)
                    System.out.printf("%c", asAsciiPrintable(bs[b]));
                System.out.println("|");

                pos += count;
            }
        }
    }

    private static char asAsciiPrintable(int b) {
        return (32 <= b && b < 127) ? (char) b : '.';
    }
}
